package ui;

import game.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import javax.swing.*;

public class GameFrame extends JFrame{
  private Game game;
  private GameView view;
  private GameController controller;
  private JFileChooser chooser;

  public GameFrame(){
    super("Game");
    game = new Game();
    initComponent();
  }

  public void initComponent(){
    chooser = new JFileChooser(".");
    ExampleFileFilter filter = new ExampleFileFilter();
    filter.addExtension("xml");
    filter.setDescription("XML files");
    chooser.setFileFilter(filter);

    view = new GameView(game);
    controller = new GameController(view, game);

    add(view);
    setJMenuBar(createMenuBar());
    pack();
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  }

  public JMenuBar createMenuBar(){
    JMenuBar menuBar = new JMenuBar();
    JMenu menu = new JMenu("File");
    JMenuItem item;

    item = new JMenuItem("Load");
    item.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        if(chooser.showOpenDialog(view) == JFileChooser.APPROVE_OPTION){
          game.loadFile(chooser.getSelectedFile());
        }
      }
    });

    menu.add(item);
    item = new JMenuItem("Exit");
    item.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        System.exit(0);
      }
    });
    menu.add(item);

    menuBar.add(menu);
    return menuBar;
  }
}
