package ui;

import game.*;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.io.File;
import java.util.List;
import java.util.ListIterator;
import javax.swing.*;

public class GameView extends JPanel{
  public static Color playerColor = Color.blue;
  public static Color enemyColor = Color.red;
  public static Color obstacleColor = Color.green;
  public static Color goalColor = Color.black;

  private Game game;
  private Game.Player grabbed;

  public GameView(Game game){
    this.game = game;

    setPreferredSize(Game.boardSize);
  }

  /**
   * `揈͂ɏ܂
   **/
  public void paintComponent(Graphics g){
    super.paintComponent(g);
    Graphics2D g2D = (Graphics2D) g;
    g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

    // S[̕`
    g2D.draw(game.getGoalRect());

    // Game.Player ̕`
    g2D.setColor(playerColor);
    for(Game.Player player : game.getPlayers()){
      Point p = player.getLocation();
      int x = (int) (p.x - Game.radius), y = (int) (p.y - Game.radius);
      int r2 = (int) (Game.radius * 2);

      if(grabbed == player)
        g2D.drawRect(x, y, r2, r2);
      
      if(player.isCaptured())
        g2D.drawOval(x, y, r2, r2);
      else if(player.isWinner())
        g2D.drawOval(x, y, r2, r2);
      else
        g2D.fillOval(x, y, r2, r2);
    }

    // Game.Enemy ̕`
    g2D.setColor(enemyColor);
    for(Game.Enemy enemy : game.getEnemies()){
      Point p = enemy.getLocation();
      int x = (int) (p.x - Game.radius), y = (int) (p.y - Game.radius);
      int r2 = (int) (Game.radius * 2);
      g2D.fillOval(x, y, r2, r2);
    }

    // Game.Obstacle ̕`
    g2D.setColor(obstacleColor);
    for(Game.Obstacle o : game.getObstacles()){
      Point p = o.getLocation();
      int r = o.getRadius();
      g2D.fillOval(p.x - r, p.y - r, r * 2, r * 2);
    }
  }

  /**
   * p ̈ʒuɂ Player ͂ (`Ƃ͋tɃXgH)
   **/
  public Game.Player grab(Point p){
    List<Game.Player> list = game.getPlayers();
    ListIterator<Game.Player> iter = list.listIterator(list.size());
    while(iter.hasPrevious()){
      Game.Player player = iter.previous();
      if(p.distance(player.getLocation()) < Game.radius){
        grabbed = player;
        return player;
      }
    }

    grabbed = null;
    return null; // p ̈ʒuɂ Player ͂Ȃ
  }
}
