package ui;

import game.*;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.JOptionPane;

public class GameController
  implements MouseListener, MouseMotionListener, KeyListener, GameStateListener{

  private GameView view;
  private Game game;

  private Game.Player grabbedPlayer;

  public GameController(GameView view, Game game){
    this.view = view;
    this.game = game;

    view.addMouseListener(this);
    view.addMouseMotionListener(this);
    view.setFocusable(true);
    view.addKeyListener(this);
    game.addGameStateListener(this);
  }

  /////////////////////////////////////////////////////////////////////////////
  // }EXCxg̏͂ɋLq܂
  /////////////////////////////////////////////////////////////////////////////

  public void mousePressed(MouseEvent e){
  }

  public void mouseReleased(MouseEvent e){
  }

  public void mouseClicked(MouseEvent e){
    // System.out.println(e.paramString()); // }EXCxg𕶎Ƃďo (fobOpH)
    grabbedPlayer = view.grab(e.getPoint());
    view.repaint();
  }

  public void mouseEntered(MouseEvent e){
  }

  public void mouseExited(MouseEvent e){
  }

  public void mouseMoved(MouseEvent e){
  }

  public void mouseDragged(MouseEvent e){
  }

  /////////////////////////////////////////////////////////////////////////////
  // L[{[hCxg̏͂ɋLq܂
  /////////////////////////////////////////////////////////////////////////////

  public void keyPressed(KeyEvent e){
    //System.out.println(e.paramString()); // L[Cxg𕶎Ƃďo (fobOpH)

    if(grabbedPlayer != null){
      switch(e.getKeyCode()){
      case KeyEvent.VK_UP:
        grabbedPlayer.setVelocity(0, -game.getPlayerMaxSpeed());
        break;
      case KeyEvent.VK_DOWN:
        grabbedPlayer.setVelocity(0, game.getPlayerMaxSpeed());
        break;
      case KeyEvent.VK_RIGHT:
        grabbedPlayer.setVelocity(game.getPlayerMaxSpeed(), 0);
        break;
      case KeyEvent.VK_LEFT:
        grabbedPlayer.setVelocity(-game.getPlayerMaxSpeed(), 0);
        break;
      }
    }
  }

  public void keyReleased(KeyEvent e){
  }

  public void keyTyped(KeyEvent e){
  }

  /////////////////////////////////////////////////////////////////////////////
  // Implementation of GameStateListener
  /////////////////////////////////////////////////////////////////////////////
  public void gameInitialized(){
    view.repaint();

    JOptionPane.showMessageDialog(view, "Press ok to start.");
    game.startGame();
  }

  public void gameProgressed(){
    view.repaint();
  }

  public void gameFinished(Result result){
    JOptionPane.showMessageDialog(view, result);
  }
}
